"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createWebpackExtend = void 0;
const logger_1 = require("../common/logger");
const consts_1 = require("../common/consts");
const helpers_1 = require("./helpers");
function createWebpackExtend(config) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield (0, helpers_1.createTemplateFile)(consts_1.extendFileName, config);
        }
        catch (error) {
            if (error) {
                logger_1.Logger.error((error === null || error === void 0 ? void 0 : error.message) || error.toString());
                throw error;
            }
            else {
                logger_1.Logger.error('The process exited with an error');
                process.exit(1);
            }
        }
    });
}
exports.createWebpackExtend = createWebpackExtend;
//# sourceMappingURL=createWebpackExtend.js.map