"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.spawnProcess = void 0;
const cross_spawn_1 = require("cross-spawn");
function spawnProcess(program, args, env) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            const proc = (0, cross_spawn_1.spawn)(program, args, {
                stdio: 'inherit',
                env: env || process.env
            });
            process.on('SIGTERM', () => proc.kill('SIGTERM'));
            process.on('SIGINT', () => proc.kill('SIGINT'));
            process.on('SIGBREAK', () => proc.kill('SIGBREAK'));
            process.on('SIGHUP', () => proc.kill('SIGHUP'));
            process.title = 'fast-serve';
            proc.on('exit', (code, signal) => {
                let crossEnvExitCode = code;
                if (crossEnvExitCode === null) {
                    crossEnvExitCode = signal === 'SIGINT' ? 0 : 1;
                }
                if (crossEnvExitCode === 1 || signal === 'SIGINT') {
                    reject();
                }
                else {
                    resolve();
                }
            });
        });
    });
}
exports.spawnProcess = spawnProcess;
//# sourceMappingURL=spawnProcess.js.map