"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamicLibraryPlugin = void 0;
const webpack_1 = __importDefault(require("webpack"));
class DynamicLibraryPlugin {
    constructor(options) {
        this.options = options;
    }
    apply(compiler) {
        compiler.webpack = webpack_1.default;
        compiler.hooks.emit.tap('DynamicLibraryPlugin', compilation => {
            for (const assetId in this.options.modulesMap) {
                const moduleMap = this.options.modulesMap[assetId];
                if (compilation.assets[assetId]) {
                    if (compilation.assets[assetId].children) {
                        const rawValue = compilation.assets[assetId].children[0]._value;
                        if (moduleMap.isBundle) {
                            compilation.assets[assetId].children[0]._value = rawValue.replace(`"${this.options.libraryName}",`, '');
                        }
                        else {
                            compilation.assets[assetId].children[0]._value = rawValue.replace(this.options.libraryName, moduleMap.id + '_' + moduleMap.version);
                        }
                    }
                    if (compilation.assets[assetId]._source) {
                        const rawValue = compilation.assets[assetId]._source.children[0];
                        if (moduleMap.isBundle) {
                            compilation.assets[assetId]._source.children[0] = rawValue.replace(`"${this.options.libraryName}",`, '');
                        }
                        else {
                            compilation.assets[assetId]._source.children[0] = rawValue.replace(this.options.libraryName, moduleMap.id + '_' + moduleMap.version);
                        }
                    }
                }
            }
        });
    }
}
exports.DynamicLibraryPlugin = DynamicLibraryPlugin;
//# sourceMappingURL=DynamicLibraryPlugin.js.map